-- Export CalcGS


function main ()
 if mappy.msgBox ("xLIB: Export Hex ASCII", "This will export the current layer into a HEX encoded ASCII string for use with xLIB etc.\nIt will automatically adjust for tile 0.", mappy.MMB_OKCANCEL, mappy.MMB_ICONQUESTION) == mappy.MMB_OK then

  local w = mappy.getValue(mappy.MAPWIDTH)
  local h = mappy.getValue(mappy.MAPHEIGHT)

  if (w == 0) then
   mappy.msgBox ("xLIB: Export Hex ASCII", "You need to load or create a map first", mappy.MMB_OK, mappy.MMB_ICONINFO)
  else

   local isok,asname = mappy.fileRequester (".", "Text Document (*.txt)", "*.txt", mappy.MMB_SAVE)
   if isok == mappy.MMB_OK then

    if (not (string.sub (string.lower (asname), -3) == ".txt")) then
     asname = asname .. ".txt"
    end

     outas = io.open (asname, "w")
     --outas:write (";Map data mappy\n\n\nmapData:");
     local y = 0
     while y < h do
      local x = 0
      local m = 0
      while x < w do
       local mapval = mappy.getBlockValue (mappy.getBlock (x, y), mappy.BLKBG)
       mapval = mapval-1
       if mapval < 0 then
        mapval = 0
       end
       if m == 0 then
        --outas:write ("\n .db ")
       end
       --outas:write ("$")
       outas:write (string.sub ("0123456789ABCDEF",mappy.shiftVal(mapval,4)+1,mappy.shiftVal(mapval,4)+1))
       outas:write (string.sub ("0123456789ABCDEF",mappy.andVal(mapval,15)+1,mappy.andVal(mapval,15)+1))
       if m < 16-1 then
        if y < (h-1) then
         if x < (w-1) then
          --outas:write (",")
         end
        end
        if y == (h-1) then
         if x < (w-1) then
          --outas:write (",")
         end
        end
       end
        x = x + 1
        m = m + 1
        if m == 16 then
         m = 0
        end
      end


      y = y + 1
      m = 0
     end
     outas:write ("\n")
     outas:close ()

   end
  end
 end
end

test, errormsg = pcall( main )
if not test then
    mappy.msgBox("Error ...", errormsg, mappy.MMB_OK, mappy.MMB_ICONEXCLAMATION)
end
